Description

It's a common idiom to use a fiber-local variable, but return a default value if it hasn't been assigned. Here's an example of Ruby
code | would expect to be able to write:

def feature_enabled?
Thread.current.fetch(:feature_enabled, true)
end
Unfortunately, Thread.current does not implement fetch, like Hash does. So | have to write the more verbose:
def feature_enabled?
Thread.current.key? (:feature_enabled) ? Thread.current[:feature_enabled] : true

end

Thanks for your consideration!

Associated revisions

Revision 7d54b4ea58bd0f072d4c368590247209e2183a54 - 02/22/2017 07:16 AM - nobu (Nobuyoshi Nakada)
Thread#fetch

e thread.c (rb_thread_fetch): add new method Thread#fetch.
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@57683 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 7d54b4ea - 02/22/2017 07:16 AM - nobu (Nobuyoshi Nakada)
Thread#fetch

e thread.c (rb_thread_fetch): add new method Thread#fetch.
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@57683 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 12/06/2016 01:26 PM - shevegen (Robert A. Heiler)

| can not say whether this feature is important or not, but on the syntax suggestion - | like the above (on the premise that it behaves as .fetch on Hash
does; | have not checked this either).

#2 - 12/06/2016 03:27 PM - nobu (Nobuyoshi Nakada)

Thread.current just returns a Thread instance, so it should be Thread#fetch method.

https://github.com/ruby/ruby/compare/trunk...nobu:feature/Thread%23fetch

#3 - 12/15/2016 05:40 AM - ko1 (Koichi Sasada)

- Assignee set to nobu (Nobuyoshi Nakada)

247257

#4 - 02/22/2017 06:55 AM - matz (Yukihiro Matsumoto)
OK.

Matz
https://github.com/ruby/ruby/compare/trunk...nobu:feature/Thread%23fetch

#5 - 02/22/2017 07:16 AM - nobu (Nobuyoshi Nakada)
- Status changed from Open to Closed

Applied in changeset r57683.

Thread#fetch

e thread.c (rb_thread_fetch): add new method Thread#fetch.
